(defmacro time-ck (form)
  `(let (real-start real-end run-start run-end x)
     (setq real-start (get-internal-real-time))
     (setq run-start (get-internal-run-time))
     (setq x (multiple-value-list ,form))
     (setq run-end (get-internal-run-time))
     (setq real-end (get-internal-real-time))
     (list* (/ (- real-end real-start) internal-time-units-per-second)
	    (/ (- run-end run-start) internal-time-units-per-second)
	    x)))

; (defmacro time (form)
;   `(let (real-start real-end run-start run-end x)
;      (setq real-start (get-internal-real-time))
;      (setq run-start (get-internal-run-time))
;      (setq x (multiple-value-list ,form))
;      (setq run-end (get-internal-run-time))
;      (setq real-end (get-internal-real-time))
;      (fresh-line *trace-output*)
;      (format *trace-output*
;              "real time : ~,3F secs~%~
;               run time  : ~,3F secs~%"
;              (/ (- real-end real-start) internal-time-units-per-second)
;              (/ (- run-end run-start) internal-time-units-per-second))
;      (values-list x)))

; (value :q)

(defun evalua-ejemplos-aux (cadena limite= funcion lista solucion)
  (declare (xargs :mode :program))
  (cond ((endp lista)
	 (format t limite=)
	 (setq si::*NOTIFY-GBC* t)
	 )
	(t (let ((resultado (time-ck
			     (apply funcion (list (cdar lista))))))
	     (if solucion
		 (format t cadena (caar lista) (caddr resultado) 
			 (car resultado))
		 (format t cadena (caar lista) (car resultado)))
	     (evalua-ejemplos-aux 
	      cadena limite= funcion (cdr lista) solucion)))))

(defun evalua-ejemplos (funcion lista &optional (solucion nil))
  (declare (xargs :mode :program))
  (setq si::*NOTIFY-GBC* nil)
  (let* ((longitud (apply #'max (cons 7 (mapcar #'(lambda (ej)
						    (length (car ej)))
						lista))))
	 (cadena (si::string-concatenate 
		  "~& | ~" (format nil "~a" longitud) 
		  (if solucion
		      "a | ~3a | ~10,3,,,' F |"
		      "a | ~10,3,,,' F |")))
	 (limite- (if solucion
		      (si::string-concatenate
		       "~& +" (make-string (+ longitud 2) :initial-element #\-)
		       "+" (make-string 5 :initial-element #\-) "+"
		       (make-string 12 :initial-element #\-) "+")
		      (si::string-concatenate
		       "~& +" (make-string (+ longitud 2) :initial-element #\-)
		       "+" (make-string 12 :initial-element #\-) "+")))
	 (limite= (if solucion
		      (si::string-concatenate
		       "~& +" (make-string (+ longitud 2) :initial-element #\=)
		       "+" (make-string 5 :initial-element #\=) "+"
		       (make-string 12 :initial-element #\=) "+")
		      (si::string-concatenate
		       "~& +" (make-string (+ longitud 2) :initial-element #\=)
		       "+" (make-string 12 :initial-element #\=) "+"))))
    (format t limite=)
    (if solucion
	(format t (si::string-concatenate 
		   "~& | ~" (format nil "~a" longitud) "a | ~3a | ~10a |")
		"Frmula" "Sol" "Tiempo")
	(format t (si::string-concatenate 
		   "~& | ~" (format nil "~a" longitud) "a | ~10a |")
		"Frmula" "Tiempo"))
    (format t limite-)
    (evalua-ejemplos-aux cadena limite= funcion lista solucion)))

; (defun evalua-ejemplos (funcion lista &optional (solucion nil))
;   (declare (xargs :mode :program))
;   (setq *gc-verbose* nil)
;   (let* ((longitud (apply #'max (cons 7 (mapcar #'(lambda (ej)
; 						    (length (car ej)))
; 						lista))))
; 	 (cadena (pcl::string-append
; 		  "~& | ~" (format nil "~a" longitud) 
; 		  (if solucion
; 		      "a | ~3a | ~10,3,,,' F |"
; 		      "a | ~10,3,,,' F |")))
; 	 (limite (if solucion
; 		     (pcl::string-append
; 		      "~& +" (make-string (+ longitud 2) :initial-element #\-)
; 		      "+" (make-string 5 :initial-element #\-) "+"
; 		      (make-string 12 :initial-element #\-) "+")
; 		     (pcl::string-append
; 		      "~& +" (make-string (+ longitud 2) :initial-element #\-)
; 		      "+" (make-string 12 :initial-element #\-) "+"))))
;     (format t limite)
;     (if solucion
; 	(format t (pcl::string-append
; 		   "~& | ~" (format nil "~a" longitud) "a | ~3a | ~10a |")
; 		"Frmula" "Sol" "Tiempo")
; 	(format t (pcl::string-append
; 		   "~& | ~" (format nil "~a" longitud) "a | ~10a |")
; 		"Frmula" "Tiempo"))
;     (format t limite)
;     (evalua-ejemplos-aux cadena limite funcion lista solucion)))

