;;;============================================================================
;;;
;;; Ttulo: Frmulas de Plaisted
;;; Parte de la tesis:
;;;    "Teora computacional (en ACL2) sobre clculos proposicionales"
;;; FJMM 08-06-02
;;;
;;;============================================================================

#| Cdigo para la certificacin:

(certify-book "../0-ejemplos/plaisted")

|#

(in-package "ACL2")

;;;============================================================================
;;;
;;; 1) Problema del palomas
;;;
;;;============================================================================

(defconst *plaisted-5*
  '( ( (- 1) (- 6)  2  )
     ( (- 2) (- 7)  3  )
     ( (- 3) (- 8)  4  )
     ( (- 4) (- 9)  5  )
     ( (- 1) (- 6)  7  )
     ( (- 2) (- 7)  8  )
     ( (- 3) (- 8)  9  )
     ( (- 4) (- 9)  10  )
     ( 1  )
     ( 6  )
     ( (- 5) (- 10)  )
     )
  )

(defconst *plaisted-6*
  '( ( (- 1) (- 7)  2  )
     ( (- 2) (- 8)  3  )
     ( (- 3) (- 9)  4  )
     ( (- 4) (- 10)  5  )
     ( (- 5) (- 11)  6  )
     ( (- 1) (- 7)  8  )
     ( (- 2) (- 8)  9  )
     ( (- 3) (- 9)  10  )
     ( (- 4) (- 10)  11  )
     ( (- 5) (- 11)  12  )
     ( 1  )
     ( 7  )
     ( (- 6) (- 12)  )
     )
  )

(defconst *plaisted-7*
  '( ( (- 1) (- 8)  2  )
     ( (- 2) (- 9)  3  )
     ( (- 3) (- 10)  4  )
     ( (- 4) (- 11)  5  )
     ( (- 5) (- 12)  6  )
     ( (- 6) (- 13)  7  )
     ( (- 1) (- 8)  9  )
     ( (- 2) (- 9)  10  )
     ( (- 3) (- 10)  11  )
     ( (- 4) (- 11)  12  )
     ( (- 5) (- 12)  13  )
     ( (- 6) (- 13)  14  )
     ( 1  )
     ( 8  )
     ( (- 7) (- 14)  )
     )
  )

(defconst *plaisted-8*
  '( ( (- 1) (- 9)  2  )
     ( (- 2) (- 10)  3  )
     ( (- 3) (- 11)  4  )
     ( (- 4) (- 12)  5  )
     ( (- 5) (- 13)  6  )
     ( (- 6) (- 14)  7  )
     ( (- 7) (- 15)  8  )
     ( (- 1) (- 9)  10  )
     ( (- 2) (- 10)  11  )
     ( (- 3) (- 11)  12  )
     ( (- 4) (- 12)  13  )
     ( (- 5) (- 13)  14  )
     ( (- 6) (- 14)  15  )
     ( (- 7) (- 15)  16  )
     ( 1  )
     ( 9  )
     ( (- 8) (- 16)  )
     )
  )

(defconst *plaisted-9*
  '( ( (- 1) (- 10)  2  )
     ( (- 2) (- 11)  3  )
     ( (- 3) (- 12)  4  )
     ( (- 4) (- 13)  5  )
     ( (- 5) (- 14)  6  )
     ( (- 6) (- 15)  7  )
     ( (- 7) (- 16)  8  )
     ( (- 8) (- 17)  9  )
     ( (- 1) (- 10)  11  )
     ( (- 2) (- 11)  12  )
     ( (- 3) (- 12)  13  )
     ( (- 4) (- 13)  14  )
     ( (- 5) (- 14)  15  )
     ( (- 6) (- 15)  16  )
     ( (- 7) (- 16)  17  )
     ( (- 8) (- 17)  18  )
     ( 1  )
     ( 10  )
     ( (- 9) (- 18)  )
     )
  )

(defconst *plaisted-10*
  '( ( (- 1) (- 11)  3  )
     ( (- 3) (- 13)  4  )
     ( (- 4) (- 14)  5  )
     ( (- 5) (- 15)  6  )
     ( (- 6) (- 16)  7  )
     ( (- 7) (- 17)  8  )
     ( (- 8) (- 18)  9  )
     ( (- 9) (- 19)  10  )
     ( (- 10) (- 20)  2  )
     ( (- 1) (- 11)  13  )
     ( (- 3) (- 13)  14  )
     ( (- 4) (- 14)  15  )
     ( (- 5) (- 15)  16  )
     ( (- 6) (- 16)  17  )
     ( (- 7) (- 17)  18  )
     ( (- 8) (- 18)  19  )
     ( (- 9) (- 19)  20  )
     ( (- 10) (- 20)  12  )
     ( 1  )
     ( 11  )
     ( (- 2) (- 12)  )
     )
  )

(defconst *plaisted*
  (list
   (cons "Plaisted 5" *plaisted-5*)
   (cons "Plaisted 6" *plaisted-6*)
   (cons "Plaisted 7" *plaisted-7*)
   (cons "Plaisted 8" *plaisted-8*)
   (cons "Plaisted 9" *plaisted-9*)
   (cons "Plaisted 10" *plaisted-10*)))

;;;============================================================================