;;;============================================================================
;;;
;;; Ttulo: Frmulas de Urquhart
;;; Parte de la tesis:
;;;    "Teora computacional (en ACL2) sobre clculos proposicionales"
;;; FJMM 08-06-02
;;;
;;;============================================================================

#| Cdigo para la certificacin:

(certify-book "../0-ejemplos/urquhart")

|#

(in-package "ACL2")

(include-book "../3-logica/sintaxis")

;;;============================================================================
;;;
;;; 1) Frmulas de Urquhart
;;;
;;;============================================================================

(defun urquhart-der (n)
  (declare (xargs :mode :program))
  (if (= n 1)
      1
      (equivalencia n (urquhart-der (- n 1)))))

(defun urquhart-izq (n m)
  (declare (xargs :mode :program))
  (if (= n 1)
      (equivalencia 1 (urquhart-der m))
      (equivalencia n (urquhart-izq (- n 1) m))))

(defun urquhart (n)
  (declare (xargs :mode :program))
  (urquhart-izq n n))

(defconst *urquhart*
  (list (cons "U_1"  (urquhart  1))
	(cons "U_2"  (urquhart  2))
	(cons "U_3"  (urquhart  3))
	(cons "U_4"  (urquhart  4)) 
	(cons "U_5"  (urquhart  5))
	(cons "U_6"  (urquhart  6))
	(cons "U_7"  (urquhart  7))
	(cons "U_8"  (urquhart  8))
	(cons "U_9"  (urquhart  9)) 
	(cons "U_10" (urquhart 10))
	(cons "U_11" (urquhart 11))
	(cons "U_12" (urquhart 12))
	(cons "U_13" (urquhart 13))
	(cons "U_14" (urquhart 14))
	(cons "U_15" (urquhart 15))))

;;;============================================================================